searchNodes=[{"doc":"Redis Sessions base module to handle the GenServer","ref":"RedisSessions.html","title":"RedisSessions","type":"module"},{"doc":"Callback implementation for Application.start/2 .","ref":"RedisSessions.html#start/2","title":"RedisSessions.start/2","type":"function"},{"doc":"","ref":"RedisSessions.html#start_link/1","title":"RedisSessions.start_link/1","type":"function"},{"doc":"The Client module contains functions to interact with the sessions.","ref":"RedisSessions.Client.html","title":"RedisSessions.Client","type":"module"},{"doc":"Query the amount of active session within the last 10 minutes (600 seconds). Note: Multiple sessions from the same user id will be counted as one. Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. dt (Integer) Delta time. Amount of seconds to check (e.g. 600 for the last 10 min.) Examples iex&gt; { :ok , _ } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 , %{ &quot;foo&quot; =&gt; &quot;bar&quot; } ) ...&gt; RedisSessions.Client . activity ( &quot;exrs-test&quot; ) { :ok , %{ activity : 1 } }","ref":"RedisSessions.Client.html#activity/2","title":"RedisSessions.Client.activity/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"RedisSessions.Client.html#child_spec/1","title":"RedisSessions.Client.child_spec/1","type":"function"},{"doc":"Create a session Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. id (Binary) The user id of this user. Note: There can be multiple sessions for the same user id. If the user uses multiple client devices. ip (Binary) IP address of the user. This is used to show all ips from which the user is logged in. ttl (Integer) optional The &quot;Time-To-Live&quot; for the session in seconds. Default: 7200. d (Map) optional Additional data to set for this sessions. (see the &quot;set&quot; method) Examples { :ok , %{ token : token } } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 , %{ &quot;foo&quot; =&gt; &quot;bar&quot; , &quot;ping&quot; =&gt; &quot;pong&quot; } )","ref":"RedisSessions.Client.html#create/5","title":"RedisSessions.Client.create/5","type":"function"},{"doc":"Get a session for an app and token Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. token (Binary) The generated session token. Must be [a-zA-Z0-9] and 64 chars long Examples { :ok , %{ token : token } } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 , %{ &quot;foo&quot; =&gt; &quot;bar&quot; } ) RedisSessions.Client . get ( &quot;exrs-test&quot; , token ) # {:ok, %{ id: &quot;foo&quot;, r: 2, w: 1, idle: 1, ttl: 3600, ip: &quot;127.0.0.1&quot;, d: %{&quot;foo&quot; =&gt; &quot;bar&quot;} }}","ref":"RedisSessions.Client.html#get/2","title":"RedisSessions.Client.get/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"RedisSessions.Client.html#init/1","title":"RedisSessions.Client.init/1","type":"function"},{"doc":"Kill a session for an app and token. Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. token (Binary) The generated session token. Must be [a-zA-Z0-9] and 64 chars long Examples iex&gt; { :ok , %{ token : token } } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 , %{ &quot;foo&quot; =&gt; &quot;bar&quot; } ) ...&gt; RedisSessions.Client . kill ( &quot;exrs-test&quot; , token ) { :ok , %{ kill : 1 } }","ref":"RedisSessions.Client.html#kill/2","title":"RedisSessions.Client.kill/2","type":"function"},{"doc":"Kill all sessions of an app Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. Examples iex&gt; { :ok , tokenA1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenB1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;bar&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenA2 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;192.168.0.42&quot; , 3600 ) ...&gt; { :ok , tokenA2 } = RedisSessions.Client . create ( &quot;exrs-test2&quot; , &quot;foo&quot; , &quot;192.168.0.42&quot; , 3600 ) ...&gt; RedisSessions.Client . killall ( &quot;exrs-test&quot; ) { :ok , %{ kill : 3 } }","ref":"RedisSessions.Client.html#killall/1","title":"RedisSessions.Client.killall/1","type":"function"},{"doc":"Kill all sessions of an id within an app Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. id (Binary) The user id of this user. Examples iex&gt; { :ok , tokenA1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenB1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;bar&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenA2 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;192.168.0.42&quot; , 3600 ) ...&gt; { :ok , tokenA2 } = RedisSessions.Client . create ( &quot;exrs-test2&quot; , &quot;foo&quot; , &quot;192.168.0.42&quot; , 3600 ) ...&gt; RedisSessions.Client . killsoid ( &quot;exrs-test&quot; , &quot;foo&quot; ) { :ok , %{ kill : 2 } }","ref":"RedisSessions.Client.html#killsoid/2","title":"RedisSessions.Client.killsoid/2","type":"function"},{"doc":"Set/Update/Delete custom data for a single session. All custom data is stored in the d object which is a simple hash object structure. d might contain a map with one or more keys with the following types: binary , number , boolean , nil . Keys with all values except nil will be stored. If a key containts nil the key will be removed. Note: If d already contains keys that are not supplied in the set request then these keys will be untouched. Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. token (Binary) The generated session token. Must be [a-zA-Z0-9] and 64 chars long d (Map) optional Data to set. Must be a map with keys whose values only consist of binaries, numbers, boolean and nil. Returns {:ok, session } the session data after change Examples { :ok , token } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 , %{ &quot;foo&quot; =&gt; &quot;bar&quot; } ) RedisSessions.Client . set ( &quot;exrs-test&quot; , token , %{ &quot;foo&quot; =&gt; &quot;buzz&quot; } ) # {:ok, %{ id: &quot;foo&quot;, r:1, w:2, idle: 3, ttl: 3600, d: %{&quot;foo&quot; =&gt; &quot;buzz&quot;} }}","ref":"RedisSessions.Client.html#set/3","title":"RedisSessions.Client.set/3","type":"function"},{"doc":"Get all sessions of an app there were active within the last 10 minutes (600 seconds). Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. dt (Integer) Delta time. Amount of seconds to check (e.g. 600 for the last 10 min.) Examples iex&gt; { :ok , tokenA } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenB } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;bar&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; RedisSessions.Client . soapp ( &quot;exrs-test&quot; ) { :ok , %{ sessions : [ %{ id : &quot;foo&quot; , r : 1 , w : 1 , idle : 1 , ttl : 3600 , d : nil } , %{ id : &quot;bar&quot; , r : 1 , w : 1 , idle : 1 , ttl : 3600 , d : nil } ] } }","ref":"RedisSessions.Client.html#soapp/2","title":"RedisSessions.Client.soapp/2","type":"function"},{"doc":"Get all sessions within an app that belong to a single id. This would be all sessions of a single user in case he is logged in on different browsers / devices. Parameters app (Binary) The app id (namespace) for this session. Must be [a-zA-Z0-9_-] and 3-20 chars long. id (Binary) The user id of this user. Examples iex&gt; { :ok , tokenA1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenB1 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;bar&quot; , &quot;127.0.0.1&quot; , 3600 ) ...&gt; { :ok , tokenA2 } = RedisSessions.Client . create ( &quot;exrs-test&quot; , &quot;foo&quot; , &quot;192.168.0.42&quot; , 3600 ) ...&gt; RedisSessions.Client . soid ( &quot;exrs-test&quot; , &quot;foo&quot; ) { :ok , [ %{ id : &quot;foo&quot; , r : 1 , w : 1 , idle : 1 , ttl : 3600 } , %{ id : &quot;bar&quot; , r : 1 , w : 1 , idle : 1 , ttl : 3600 } ] }","ref":"RedisSessions.Client.html#soid/2","title":"RedisSessions.Client.soid/2","type":"function"},{"doc":"start genserver","ref":"RedisSessions.Client.html#start_link/1","title":"RedisSessions.Client.start_link/1","type":"function"},{"doc":"Wipe all deprecated sessions Parameters","ref":"RedisSessions.Client.html#wipe/0","title":"RedisSessions.Client.wipe/0","type":"function"},{"doc":"","ref":"RedisSessions.Client.html#t:app/0","title":"RedisSessions.Client.app/0","type":"type"},{"doc":"","ref":"RedisSessions.Client.html#t:id/0","title":"RedisSessions.Client.id/0","type":"type"},{"doc":"","ref":"RedisSessions.Client.html#t:ip/0","title":"RedisSessions.Client.ip/0","type":"type"},{"doc":"","ref":"RedisSessions.Client.html#t:session/0","title":"RedisSessions.Client.session/0","type":"type"},{"doc":"","ref":"RedisSessions.Client.html#t:token/0","title":"RedisSessions.Client.token/0","type":"type"},{"doc":"A library of functions used to create and use a Redis pool through Redix.","ref":"RedisSessions.RedixPool.html","title":"RedisSessions.RedixPool","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"RedisSessions.RedixPool.html#child_spec/1","title":"RedisSessions.RedixPool.child_spec/1","type":"function"},{"doc":"execute a singleredis command Examples iex&gt; RedisSessions.RedixPool . command ~w(PING) { :ok , &quot;PONG&quot; }","ref":"RedisSessions.RedixPool.html#command/1","title":"RedisSessions.RedixPool.command/1","type":"function"},{"doc":"init redix pool","ref":"RedisSessions.RedixPool.html#init/1","title":"RedisSessions.RedixPool.init/1","type":"function"},{"doc":"execute mutliple redis commands at once. Examples iex&gt; RedisSessions.RedixPool . pipeline ( [ ~w(SET redissessions-test woohoo!) , ~w(GET redissessions-test) , ~w(DEL redissessions-test) ] ) { :ok , [ &quot;OK&quot; , &quot;woohoo!&quot; , 1 ] } iex&gt; RedisSessions.RedixPool . pipeline ( [ [ &quot;SET&quot; , &quot;redissessions-list&quot; , &quot;woohoo!&quot; ] , [ &quot;GET&quot; , &quot;redissessions-list&quot; ] , [ &quot;DEL&quot; , &quot;redissessions-list&quot; ] ] ) { :ok , [ &quot;OK&quot; , &quot;woohoo!&quot; , 1 ] }","ref":"RedisSessions.RedixPool.html#pipeline/1","title":"RedisSessions.RedixPool.pipeline/1","type":"function"},{"doc":"start supervisor","ref":"RedisSessions.RedixPool.html#start_link/1","title":"RedisSessions.RedixPool.start_link/1","type":"function"},{"doc":"RedisSessions This is a Elixir module to keep sessions in a Redis datastore and add some useful methods. The main purpose of this module is to generalize sessions across application server platforms. It's also an elixir port of the node.js module redis-sessions .","ref":"readme.html","title":"RedisSessions","type":"extras"},{"doc":"If available in Hex , the package can be installed as: Add redis_sessions to your list of dependencies in mix.exs : ` ` ` elixir def deps do [ { :redis_sessions , &quot;~&gt; 0.1.0&quot; } ] end ` ` ` Ensure redis_sessions is started before your application: ` ` ` elixir def application do [ applications : [ :redis_sessions ] ] end ` ` `","ref":"readme.html#installation","title":"RedisSessions - Installation","type":"extras"},{"doc":"Basic methods create a session - create/6 { :ok , %{ token : token } } = RedisSessions.Client . create ( &quot;appname&quot; , &quot;the_users_id&quot; , &quot;127.0.0.1&quot; ) Get a session - get/3 session_token = &quot;q3uvHvVqEcnTAaIsWSkgAcvDSKsTyVyameD3s7TjBU1lMVeB3hW7bsgZitfoxqkr&quot; { :ok , session } = RedisSessions.Client . create ( &quot;appname&quot; , session_token ) # session -&gt; %{ id: &quot;the_users_id&quot;, r:2, w:1, idle: 3, ttl: 3600, d: nil } Add additional data to the session - set/4 session_token = &quot;q3uvHvVqEcnTAaIsWSkgAcvDSKsTyVyameD3s7TjBU1lMVeB3hW7bsgZitfoxqkr&quot; session_data = %{ &quot;my&quot; =&gt; &quot;additional&quot; , &quot;data&quot; =&gt; 2 , &quot;save&quot; =&gt; &quot;to&quot; , &quot;my&quot; =&gt; &quot;session&quot; } { :ok , session } = RedisSessions.Client . set ( &quot;appname&quot; , session_token , session_data ) # session -&gt; %{ id: &quot;the_users_id&quot;, r:2, w:2, idle: 3, ttl: 3600, ip: &quot;127.0.0.1&quot;, d: %{ &quot;my&quot; =&gt; &quot;additional&quot;, &quot;data&quot; =&gt; 2, &quot;save&quot; =&gt; &quot;to&quot;, &quot;my&quot; =&gt; &quot;session&quot; } } Kill a session - kill/3 session_token = &quot;q3uvHvVqEcnTAaIsWSkgAcvDSKsTyVyameD3s7TjBU1lMVeB3hW7bsgZitfoxqkr&quot; { :ok , %{ kill : 1 } } = RedisSessions.Client . kill ( &quot;appname&quot; , session_token , session_data ) Special user methods Get all sessions of a user's id - soid/3 { :ok , sessions } = RedisSessions.Client . soid ( &quot;appname&quot; , &quot;the_users_id&quot; ) # sessions -&gt; [ # %{ id: &quot;the_users_id&quot;, r:2, w:2, idle: 3, ttl: 3600, ip: &quot;127.0.0.1&quot;, d: %{ &quot;my&quot; =&gt; &quot;additional&quot;, &quot;data&quot; =&gt; 2, &quot;save&quot; =&gt; &quot;to&quot;, &quot;my&quot; =&gt; &quot;session&quot; } }, # %{ id: &quot;the_users_id&quot;, r:13, w:23, idle: 42, ttl: 3600, ip: &quot;192.168.1.23&quot; } # ] Kill all sessions of a user's id - killsoid/3 { :ok , %{ kill : 3 } } = RedisSessions.Client . killsoid ( &quot;appname&quot; , &quot;the_users_id&quot; ) Special app methods Get the count of active sessions - activity/3 { :ok , %{ activity : 1 } } = RedisSessions.Client . activity ( &quot;appname&quot; ) Get all sessions of an app - soapp/3 { :ok , sessions } = RedisSessions.Client . soapp ( &quot;appname&quot; ) # sessions -&gt; [ # %{ id: &quot;the_users_id&quot;, r: 2, w: 2, idle: 3, ttl: 3600, ip: &quot;127.0.0.1&quot;, d: %{ &quot;my&quot; =&gt; &quot;additional&quot;, &quot;data&quot; =&gt; 2, &quot;save&quot; =&gt; &quot;to&quot;, &quot;my&quot; =&gt; &quot;session&quot; } }, # %{ id: &quot;the_users_id&quot;, r: 13, w: 23, idle: 42, ttl: 3600, ip: &quot;192.168.1.23&quot; }, # %{ id: &quot;another_user&quot;, r: 1, w: 42, idle: 666, ttl: 9999, ip: &quot;192.168.1.13&quot; } # ] Kill all sessions aof an app - killall/2 { :ok , %{ kill : 3 } } = RedisSessions.Client . killall ( &quot;appname&quot; )","ref":"readme.html#usage","title":"RedisSessions - Usage","type":"extras"},{"doc":"A Session map will look like: %{ id : &quot;the_users_id&quot; , r : 2 , w : 1 , idle : 3 , ttl : 3600 , ip : &quot;127.0.0.1&quot; , d : nil } Attributes: id Binary : The sessions/users id you defined during the .create/6 method. idle Number : The idle time of this session in seconds r Number : The number of reads of this session w Number : The number of writes to this session ttl Number : The time to live for this session in seconds ip Binary : The ip you set during create. Could be used to differ the same user on different devices/platforms. d Map : A map of additional data saved to this session","ref":"readme.html#session-attributes","title":"RedisSessions - Session Attributes","type":"extras"},{"doc":"ns Binary defaukt: rs : redis sessions namespace wipe Number defaukt: 600 : redis sessions wipe timeout. If set to 0 automatic wipeing will be disabled redis Binary : redis connection string. E.g. &quot;redis://localhost:6379/0&quot;, pool_size Number defaukt: 1 : redix/poolboy pool size pool_overflow Number defaukt: 0 : redix/poolboy pool overflow","ref":"readme.html#config","title":"RedisSessions - Config","type":"extras"},{"doc":"Version Date Description 0.2.3 2017-08-01 optimized travic config and relaxed elixir version 0.2.2 2017-08-01 updated dependencies and elixir requirement 0.2.1 2016-12-09 relaxed poison dependency 0.2.0 2016-12-09 Fixed configuration via system env like { :system, &quot;CUSTOM_SESSIONS_WIPE&quot;, 120 } ; updated deps 0.1.3 2016-09-29 fixed wipe config = 0; Optimized code based on credo hints; added automatic code coverage report 0.1.2 2016-09-28 fixed la timestamp to seconds to be compatible with redis-sessions 0.1.1 2016-09-28 use regular json encoding without key to atom feature. Added debug infos 0.1.0 2016-09-28 Initial finished version 0.0.1 2016-09-27 Main calls done 0.0.0 2016-09-16 development ...","ref":"readme.html#release-history","title":"RedisSessions - Release History","type":"extras"},{"doc":"Copyright © 2016 M. Peter, http://www.tcs.de Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#the-mit-license-mit","title":"RedisSessions - The MIT License (MIT)","type":"extras"}]